<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Class Model_Plan
 *
 * @property-read   $ID             int
 * @property        $ExternalID     string
 * @property        $FacultyID      int
 * @property        $SemesterID     int
 * @property        $GradeID        int
 */
class Model_Plan extends Model_Container
{
    protected function getRawData($id) {
        $sql = 'CALL `Plan_GetInfo`(:id)';
        $info = DB::query(Database::SELECT, $sql)
            ->param(':id', $id)->execute();

        if ($info->count() == 0)
            throw new InvalidArgumentException('Study plan not found');

        return $info->offsetGet(0);
    }

    public static function make() {
        return new Model_Helper_PlanBuilder();
    }

    protected function create() {
//        $sql = 'SELECT `CreateStudentGroupSearch`(LastName, FirstName, SecondName, GradeID, GroupNum, FacultyID, ActivationCode, SemesterID) AS `ID`';
//
//        $this->data[self::$ID_FIELD] = DB::query(Database::SELECT, $sql)
//            ->parameters($this->data)
//            ->execute()->get('ID');
//
//        if ($this->ID <= 0)
//            throw new InvalidArgumentException(Error::INVALID_PARAMETERS);
    }

    public static function withExternalID($extid) {
        $sql = 'SELECT `Plan_GetIDFromExternalID`(:ExtID) AS `ID`';
        $res = DB::query(Database::SELECT, $sql)
            ->param(':ExtID', $extid)
            ->execute()->get('ID');
        return $res;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($semesterID = null) {
        throw new BadMethodCallException('Method is not implemented yet!');
    }

    public function getTeachers($loadAll = false, $semesterID = null) {
        throw new BadMethodCallException('Method is not implemented yet!');
    }

    // todo implementation
    public function update() {
        throw new BadMethodCallException('Method is not implemented yet!');
    }
}
